VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1050
   ClientLeft      =   2385
   ClientTop       =   4110
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1050
   ScaleWidth      =   4680
   Begin VB.CheckBox Check1 
      Caption         =   "Lancer au d&marrage de Windows"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   360
      Width           =   3375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'________________________________________________________________
'|   Source Tlcharge sur le site http://www.lesiteweb.fr.st  |
'|   Merci de laisser cet en tte en cas de copie de la source. |
'


Option Explicit

'APIs pour la cration de raccourcis
Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" _
    (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" _
    (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long

'Attention :
'Si vous avez VB5, la dll contenant la fonction de raccourci est VB5stkit.DLL
'Si vous avez VB4, la dll est STkit432.dll

Private Declare Function fCreateShellLink Lib "VB5stkit.dll" _
    (ByVal lpstrFolderName As String, _
    ByVal lpstrLinkName As String, _
    ByVal lpstrLinkPath As String, _
    ByVal lpstrLinkArgs As String) As Long

Function FICH_EXIST(Fichier As String) As Boolean
'Pour savoir si un fichier existe ou non

Dim i As Long

On Error GoTo Erreur

i = FileLen(Fichier)    'Cherche la taille du fichier
FICH_EXIST = True       'Si pas d'erreur, le fichier existe
Exit Function

Erreur:                 'Si erreur (il vaudrait mieux faire un test de l'erreur)
FICH_EXIST = False      'le fichier n'existe pas


End Function


Function CHEMIN_RELATIF(Chemin1 As String, CheminRef As String) As String
'Renvoie l'adresse de Chemin1 (qui est un dossier) relativement
' CheminRef

'Attention : Chemin1 et CheminRef doivent tre donns sans le \ final

'Ex : Si Chemin1 = "c:\program files" et CheminRef = "c:\windows"
'alors CHEMIN_RELATIF = "..\program files"


Dim Morceau1() As String, Morceau2() As String
Dim TailleMorceau1 As Integer, TailleMorceau2 As Integer

Dim i As Integer, j As Integer
Dim Prov As String

ReDim Morceau1(1 To 1)
ReDim Morceau2(1 To 1)

'*** Marque chaque lment du chemin dans un tableau

'* pour chemin1
For i = 1 To Len(Chemin1)
    If Mid(Chemin1, i, 1) = "\" Then
        TailleMorceau1 = TailleMorceau1 + 1
        ReDim Preserve Morceau1(1 To TailleMorceau1)
        Morceau1(TailleMorceau1) = Prov
        Prov = ""
    Else
        Prov = Prov & Mid(Chemin1, i, 1)
    End If
Next i

'rajoute le dernier lment (non prcd d'un slash)
TailleMorceau1 = TailleMorceau1 + 1
ReDim Preserve Morceau1(1 To TailleMorceau1)
Morceau1(TailleMorceau1) = Prov


'* pour CheminRef
For i = 1 To Len(CheminRef)
    If Mid(CheminRef, i, 1) = "\" Then
        TailleMorceau2 = TailleMorceau2 + 1
        ReDim Preserve Morceau2(1 To TailleMorceau2)
        Morceau2(TailleMorceau2) = Prov
        Prov = ""
    Else
        Prov = Prov & Mid(CheminRef, i, 1)
    End If
Next i

TailleMorceau2 = TailleMorceau2 + 1
ReDim Preserve Morceau2(1 To TailleMorceau2)
Morceau2(TailleMorceau2) = Prov


Prov = ""
For i = 1 To TailleMorceau2 - 1
    Prov = Prov & "..\"
Next i

For i = 2 To TailleMorceau1
    Prov = Prov & Morceau1(i) & "\"
Next i

CHEMIN_RELATIF = Left(Prov, Len(Prov) - 1)  'retire le "\" final


End Function





Sub CREER_RACCOURCI()
'Cre un raccourci vers le programme dans le dossier de dmarrage

Dim CheminApp As String
Dim NomFichier As String
Dim DossierProg As String
Dim DossierDemarrage As String
Dim DossierRelatif As String

'note le chemin de l'application, et rajoute un \  la fin s'il n'y en avait pas
If Right(App.Path, 1) = "\" Then
    CheminApp = App.Path
Else
    CheminApp = App.Path & "\"
End If

NomFichier = CheminApp & App.EXEName & ".exe"   'Nom du fichier exe

'Trouve le dossier Dmarrer\Programmes et rajoute un \ s'il n'y en avait pas
DossierProg = GetSpecialFolder(2)
DossierProg = IIf(Right(DossierProg, 1) = "\", Left(DossierProg, Len(DossierProg) - 1), DossierProg)

'Idem avec Dmarrer\Programmes\Dmarrage
DossierDemarrage = GetSpecialFolder(7)
DossierDemarrage = IIf(Right(DossierDemarrage, 1) = "\", Left(DossierDemarrage, Len(DossierDemarrage) - 1), DossierDemarrage)

'Trouve l'adresse de DossierDemarrage relativement  DossierProg (indispensable pour utiliser fCreateShellLink)
DossierRelatif = CHEMIN_RELATIF(DossierDemarrage, DossierProg)

Call fCreateShellLink(DossierRelatif, App.Title, NomFichier, "")


End Sub


Function GetSpecialFolder(CSIDL As Long) As String
'rcupre un dossier spcial style c:\windows, c:\windows\recent...

'variables ncessaires
Dim r As Long
Dim sPath As String
Dim IDL As ITEMIDLIST
Const NOERROR = 0
Const MAX_LENGTH = 260

  'fill the idl structure with the specified folder item
r = SHGetSpecialFolderLocation(Form1.hWnd, CSIDL, IDL)
If r = NOERROR Then
    'Of the structure is filled, initialize and
    'retrieve the path from the id list, and return
    'the folder with a trailing slash appended.
    sPath = Space$(MAX_LENGTH)
    r = SHGetPathFromIDList(ByVal IDL.mkid.cb, ByVal sPath)
    If r Then
        GetSpecialFolder = Left$(sPath, _
        InStr(sPath, Chr$(0)) - 1) & "\"
    End If
End If

End Function





Private Sub Check1_Click()

Dim MenuDemarrage As String   'Donne de la valeur que l'on cherche  lire


'Cherche le dossier de dmarrage
MenuDemarrage = GetSpecialFolder(&H7)
If Right(MenuDemarrage, 1) <> "\" Then MenuDemarrage = MenuDemarrage & "\"  'rajoute un \  la fin s'il n'y tait pas


If Check1.Value = 1 Then   'Si lancer au dmarrage
    CREER_RACCOURCI 'on cre le raccourci
Else        'Si ne pas lancer au dmarrage
    If FICH_EXIST(MenuDemarrage & App.Title & ".lnk") = True Then Kill MenuDemarrage & App.Title & ".lnk" 'on supprime le raccourci s'il existait
End If


End Sub

Private Sub Form_Load()

'________________________________________________________________
'|   Source Tlcharge sur le site http://www.lesiteweb.fr.st  |
'|   Merci de laisser cet en tte en cas de copie de la source. |
'
'
' DESCRIPTION :
' Ce code vous permettra de crer des raccourcis
' vers votre programme. Dans cet exemple, le raccourci
' est ajout au menu Dmarrage afin que le programme
' soit lanc automatiquement au dmarrage de Windows.
' Cet exemple permet aussi de connare l'adresse d'un
' dossier relativement  un autre dossier (voir la
' fonction CHEMIN_RELATIF.
'
'________________________________________________________________
'|   Source Tlcharge sur le site http://www.lesiteweb.fr.st  |
'|   Merci de laisser cet en tte en cas de copie de la source. |
'



End Sub


